/////  CadTest -  how a cad program might use WinTab. RICO 4/1/92  //////

#include <string.h>
#include <windows.h>
#include "msgpack.h"
#include <commdlg.h>
#include <wintab.h>
#define PACKETDATA	(PK_X | PK_Y | PK_BUTTONS)
#define PACKETMODE	PK_BUTTONS
#include <pktdef.h>
#include "cadtest.h"
#ifdef USE_X_LIB
#include <wintabx.h>
#endif


/////@O[oϐ@//////////////////////////////////////////////////////


 HANDLE hInst;
 HPEN	_PEN00V,_PEN01;					//MS

#ifdef WIN32
	#define GetID()	GetCurrentProcessId()
#else
	#define GetID()	hInst
#endif

 char szFile[256] = "cadtest.ctx";


 BYTE	_BTNst[4];					//0ȂO񉟂ĂȂA1Ȃ牟Ă

 WORD	_WD=512,_HT=704;					//JoX,
 WORD	_WDBx,_WDBy;						//g̕

 WORD	_CRTx,_CRTy;						//ʉ𑜓x


 WORD	lx=0xffff,ly;				// linen_W lx0xffff Ȃ͈Ȃ

 HBITMAP	hbmp=NULL;			// zʂBMPnh
 HBITMAP	hbmld;				// 摜[hpBMPnh
 BYTE		*bmpadr;			// BMP{̂̃AhX

 //BMPINFO           Œ  ,    bit/plane   k size@ dpm     @pal F
 DWORD bINFO[10+256]={ 40, 512, 704,   0x00080001, 0,   0,    0, 0,     256,16,
  0x000000,0xa8a8a8 													//pbg 0xrrggbb
 };

 BYTE	_buf[256];


 LOGCONTEXT lcMine;					//^ubgRg[p\



/////    ///////////////////////////////////////////////////////////

int PASCAL WinMain(HANDLE hInstance,HANDLE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
 MSG msg;

 if (!hPrevInstance)
 if (!InitApplication(hInstance))
		return (FALSE);

	/* Perform initializations that apply to a specific instance */
 if (!InitInstance(hInstance, nCmdShow)){ return (FALSE); }

/////
												//zʍ쐬
 hbmp=CreateDIBSection(NULL,(BITMAPINFO *)bINFO, DIB_RGB_COLORS,&bmpadr  ,NULL,0);
 if(hbmp==NULL){ MessageBox(NULL,"DIBsection쐬s","status",MB_OK); return (FALSE); }

 GdiFlush();
 bINFO[265]=0xffffff;				//pbg255=
 memset(bmpadr,255,_WD*_HT);		//zʃNA


 _PEN00V= CreatePen(PS_SOLID,1, 0x02989898);			//1dot D
 _PEN01=  CreatePen(PS_SOLID,16,0x02ffffff);			//16dot 




/////  WndProcɐn

 while (GetMessage(&msg,NULL,0,0)){
  TranslateMessage(&msg); DispatchMessage(&msg);
 }

 DeleteObject(_PEN00V); DeleteObject(_PEN01);			// yJ
 DeleteObject(hbmp);									// z(DibSection)J


#ifdef USE_X_LIB
	_UnlinkWintab();
#endif
	return (msg.wParam);
}


/////@Tu[`

///@@@wndclasso^

BOOL InitApplication(hInstance)
HANDLE hInstance;
{
	WNDCLASS  wc;

	/* Fill in window class structure with parameters that describe the       */
	/* main window.                                                           */

	wc.style = 0;
	wc.lpfnWndProc = MainWndProc;

	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground =  (HBRUSH)GetStockObject(WHITE_BRUSH);	// wiF()
	wc.lpszMenuName =  NULL;									// j[
	wc.lpszClassName = "CadTestWClass";

	/* Register the window class and return success/failure code. */

	return (RegisterClass(&wc));

}

///@@@쐬

BOOL InitInstance(HANDLE hInstance,int nCmdShow){
 RECT	wsz,csz,csz2,dtpsz;			//̑S̃TCY,clienẗTCY
 HDC hdc;
 HWND hwnd;
 char buf[50];

	/* Save the instance handle in static variable, which will be used in  */
	/* many subsequence calls from this application to Windows.            */

 hInst = hInstance;

	/* check if WinTab available. */
 if (!WTInfo(0, 0, NULL)) {
	MessageBox(NULL, "WinTab Services Not Available.", "WinTab",
				MB_OK | MB_ICONHAND);
	return FALSE;
 }

	/* Create a main window for this application instance.  */

 wsprintf(buf, "CadTest:%x", GetID());
 hwnd = CreateWindow(
		"CadTestWClass",
		buf,
		WS_OVERLAPPED |WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX,
		0,0, 256,256,					// windoẅʒu(x,y),傫(x,y)
		NULL,
		NULL,
		hInstance,
		NULL
 );

	/* If window could not be created, return "failure" */

 if (!hwnd){ return (FALSE); }

 hdc=GetDC(hwnd);
 _CRTx=GetDeviceCaps(hdc,HORZRES); _CRTy=GetDeviceCaps(hdc,VERTRES);
 ReleaseDC(hwnd,hdc);

	//wsprintf(_buf,"(%d,%d)\nʂ",_CRTx,_CRTy);						//debug
	//MessageBox(hwnd,_buf,"status",MB_OK);


 GetWindowRect(hwnd,&wsz);		//S̃TCY
 GetClientRect(hwnd,&csz);		//cl̈TCY(XN[o[)

 _WDBx=(wsz.right-wsz.left)-(csz.right-csz.left);			//gTCYx
 _WDBy=(wsz.bottom-wsz.top)-(csz.bottom-csz.top);			//gTCYy

 MoveWindow(hwnd ,100,0, _WD+_WDBx, _HT+_WDBy,TRUE);



 ShowWindow(hwnd, nCmdShow);
 UpdateWindow(hwnd);
 return (TRUE);

}

/////@Tu[`@////////////////////////////////////////////////////////


/////  TabletSetup:

/* enforces context rules even if we didn't save the context. */

void static NEAR TabletSetup(PLOGCONTEXT pLc)
{
	/* modify the digitizing region */

	wsprintf(pLc->lcName, "CadTest Digitizing %x", GetID());
	pLc->lcOptions |= CXO_MESSAGES;
	pLc->lcMsgBase = WT_DEFBASE;
	pLc->lcPktData = PACKETDATA;
	pLc->lcPktMode = PACKETMODE;
	pLc->lcMoveMask = PACKETDATA;
	pLc->lcBtnUpMask = pLc->lcBtnDnMask;

	//pLc->lcOutOrgX = pLc->lcOutOrgY = 0;	//Wn(0,0)-(2047,1535)
	//pLc->lcOutExtX = 2048;
	//pLc->lcOutExtY = 1536;
}


/////@TabletRestore:

HCTX static TabletRestore(HCTX hCtx, HWND hwnd)
{
	void *save_buf;
	UINT save_size;
	HFILE hFile;
	OFSTRUCT ofs;
	LOGCONTEXT lc;

	/* alloc a save buffer. */
	WTInfo(WTI_INTERFACE, IFC_CTXSAVESIZE, &save_size);
	if (save_buf = (void *)LocalAlloc(LPTR, save_size))
	{
		OPENFILENAME ofn;

		/* do open file box. */
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hwnd;
		ofn.lpstrFilter = "Context Files\0*.ctx\0";
		ofn.lpstrFile = szFile;
		ofn.nMaxFile = sizeof(szFile);
		ofn.Flags = OFN_FILEMUSTEXIST |OFN_PATHMUSTEXIST;
		ofn.lpstrDefExt = "ctx";

		if (GetOpenFileName(&ofn)) {

			/* open the file. */
			if ((hFile = OpenFile(szFile, &ofs, OF_READ)) != HFILE_ERROR)
			{
				/* read in the data. */
				_lread(hFile, save_buf, save_size);

				/* close the file. */
				_lclose(hFile);
			}

			/* restore the context, disabled. */
			if (hCtx)
				WTClose(hCtx);
			hCtx = WTRestore(hwnd, save_buf, FALSE);
			/* re-init the context. */
			if (hCtx) {
				WTGet(hCtx, &lc);
				TabletSetup(&lc);
				WTSet(hCtx, &lc);

				/* open for real. */
				WTEnable(hCtx, TRUE);
			}
		}
		/* bag the save buffer. */
		LocalFree((HLOCAL)save_buf);
	}
	return hCtx;
}


/////@TabletSave:

void TabletSave(HCTX hCtx, HWND hwnd, BOOL fAs)
{

	void *save_buf;
	UINT save_size;
	HFILE hFile;
	OFSTRUCT ofs;

	/* alloc a save buffer. */
	WTInfo(WTI_INTERFACE, IFC_CTXSAVESIZE, &save_size);
	if (save_buf = (void *)LocalAlloc(LPTR, save_size))
	{
		/* save the data. */
		if (WTSave(hCtx, save_buf)) {

			/* if setting file name... */
			if (fAs) {
				OPENFILENAME ofn;

				/* do save file box. */
				memset(&ofn, 0, sizeof(ofn));
				ofn.lStructSize = sizeof(ofn);
				ofn.hwndOwner = hwnd;
				ofn.lpstrFilter = "Context Files\0*.ctx\0";
				ofn.lpstrFile = szFile;
				ofn.nMaxFile = sizeof(szFile);
				ofn.Flags = OFN_PATHMUSTEXIST;
				ofn.lpstrDefExt = "ctx";

				fAs = GetSaveFileName(&ofn);
			}
			else
				/* assume file name good. */
				fAs = TRUE;

			/* if good file name... */
			if (fAs) {
				/* open the file. */
				if ((hFile = OpenFile(szFile, &ofs, OF_WRITE | OF_CREATE)) !=
						HFILE_ERROR)
				{
					/* read in the data. */
					_lwrite(hFile, save_buf, save_size);

					/* close the file. */
					_lclose(hFile);
				}
			}
		}
		/* bag the save buffer. */
		LocalFree((HLOCAL)save_buf);
	}
}

/////@TabletInit:

HCTX static NEAR TabletInit(HWND hwnd)
{

	/* get default region */
	WTInfo(WTI_DEFCONTEXT, 0, &lcMine);		//ftHgllcmineɎ擾


	//wsprintf(_buf,"(%d,%d)-(%d,%d)\nʂ",						//debug
	// lcMine.lcOutOrgX,lcMine.lcOutOrgY,	lcMine.lcOutExtX,lcMine.lcOutExtY);
	//MessageBox(hwnd,_buf,"status",MB_OK);

	//PenStation̕\:3248*2320



	TabletSetup(&lcMine);					//KvȂƂ

	/* open the region */
	return WTOpen(hwnd, &lcMine, TRUE);

}


/////  wndproc̏  //////////////////////////////////////////////////////

LRESULT FAR PASCAL MainWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){

 FARPROC lpProcAbout;
 static HCTX hTab = NULL;
 static POINT ptOld, ptNew, _po;
 static RECT rcClient;
 PAINTSTRUCT psPaint;
 HDC hdc,hdcv;
 PACKET pkt;
 BOOL fHandled = TRUE;
 LRESULT lResult = 0L;
 static int count;
 static BOOL fPersist;

 RECT	_cr;
 DWORD	i,x,y, xt,yt, ff,eax;
 BYTE	ebx;



 switch (message) {


/////@@WM_COMMAND:

 case WM_COMMAND:
	switch (GET_WM_COMMAND_ID(wParam, lParam)) {
	case IDM_ABOUT:
		lpProcAbout = MakeProcInstance(About, hInst);
		DialogBox(hInst, "AboutBox", hwnd, lpProcAbout);
		//FreeProcInstance(lpProcAbout);			//Win32ƖӖ
		break;

	case IDM_OPEN:
		hTab = TabletRestore(hTab, hwnd);
		break;

	case IDM_SAVE:
		TabletSave(hTab, hwnd, FALSE);
		break;

	case IDM_SAVE_AS:
		TabletSave(hTab, hwnd, TRUE);
		break;

	case IDM_CONFIG:
		WTConfig(hTab, hwnd);
		break;

	case IDM_PERSIST:
		fPersist = !fPersist;
		CheckMenuItem(GetSubMenu(GetMenu(hwnd), IDM_EDIT),
			IDM_PERSIST, (fPersist ? MF_CHECKED : MF_UNCHECKED));
		break;

	default:
		fHandled = FALSE;
		break;
	}
	break;


/////@@WT_PACKET: ^ubg
 // {^ꂽ c O̓_ł
 // WOƈႤ c {^ĂԂȂ
 //


 case WT_PACKET:
  if(WTPacket((HCTX)lParam, wParam, &pkt)) {
   ff=0;
   ptOld = ptNew;


	xt=lcMine.lcOutExtX - lcMine.lcOutOrgX;			//^ubgL𑜓xx
	yt=lcMine.lcOutExtY - lcMine.lcOutOrgY;			//^ubgL𑜓xy

	x=pkt.pkX - lcMine.lcOutOrgX;					//^ubg̍W
	y=pkt.pkY - lcMine.lcOutOrgY;

	ptNew.x=(x *_CRTx)/xt;					//XN[Wɕϊ
	ptNew.y=_CRTy-((y *_CRTy)/yt);			//̂y͏㉺t

   _po.x=0; _po.y=0; ClientToScreen(hwnd,&_po);
   x=ptNew.x - _po.x; y=ptNew.y - _po.y;			//NCAgWɕϊ

   if (ptNew.x != ptOld.x || ptNew.y != ptOld.y) {			//WĂ
	SetCursorPos(ptNew.x,ptNew.y); 							//J[\Ǐ]
   }

	i=LOWORD(pkt.pkButtons);
	if (HIWORD(pkt.pkButtons)==TBN_DOWN){		//{^ꂽ
	 _BTNst[i]=1;
     wsprintf(_buf,"CADTEST: botton=%d",i);
	 SendMessage(hwnd,WM_SETTEXT,0,(LPARAM)_buf);
	 ff=1;
	 lx=x; ly=y;					//Wm̐=_

	}else if(HIWORD(pkt.pkButtons)==TBN_UP){		//{^ꂽ
	 _BTNst[i]=0;
	}


   if(x < rcClient.right  && y < rcClient.bottom){			//J[\clGAȂc
	hdc=GetDC(hwnd);
	hdcv= CreateCompatibleDC(hdc); SelectObject(hdcv,hbmp);


	if(ff==0){
	 if (ptNew.x != ptOld.x || ptNew.y != ptOld.y) {			//W
	  if(_BTNst[0]==1){										//y悪Ă
	   lx=ptOld.x - _po.x; ly=ptOld.y - _po.y;
	   if(lx < rcClient.right  && ly < rcClient.bottom){ ff=1; }
	  }
     }
    }

    if(ff){												//
	 MoveToEx(hdc, lx,ly,NULL); LineTo(hdc, x,y);
	 MoveToEx(hdcv,lx,ly,NULL); LineTo(hdcv,x,y);
    }

    DeleteDC(hdcv); ReleaseDC(hwnd,hdc);
   }													//

  }
  break;


/////@@WM_ACTIVATE: ^XNɗ or Oꂽ

 case WM_ACTIVATE:
	if (GET_WM_ACTIVATE_STATE(wParam, lParam))
		InvalidateRect(hwnd, NULL, TRUE);

	/* if switching in the middle, disable the region */
	if (hTab) {
		if (!fPersist)
			WTEnable(hTab, GET_WM_ACTIVATE_STATE(wParam, lParam));

		if (hTab && GET_WM_ACTIVATE_STATE(wParam, lParam))
			WTOverlap(hTab, TRUE);
	}
	break;


/////@@WM_PAINT: ʕ\

 case WM_PAINT:
  count = 0;
  hdc = BeginPaint(hwnd, &psPaint);
  hdcv= CreateCompatibleDC(hdc); SelectObject(hdcv,hbmp);

  SetDIBColorTable(hdcv,0,256, &bINFO[10]);		//bINFO+10 ł


  BitBlt(hdc,0,0,_WD,_HT,hdcv,0,0,SRCCOPY);


  DeleteDC(hdcv);
  EndPaint(hwnd,&psPaint);
  return 0;



/////     ̑WM:

		case WM_CREATE:
			hTab = TabletInit(hwnd);
			if (!hTab) {
				MessageBox(NULL, " Could Not Open Tablet Context.", "WinTab",
							MB_OK | MB_ICONHAND);

				SendMessage(hwnd, WM_DESTROY, 0, 0L);
			}
			break;


		case WM_SIZE:
			GetClientRect(hwnd, &rcClient);
			InvalidateRect(hwnd, NULL, TRUE);
			break;



		case WM_DESTROY:
			if(hTab) WTClose(hTab);
			PostQuitMessage(0);
			break;

/////

		default:
			fHandled = FALSE;
			break;
	}
	if (fHandled)
		return (lResult);
	else
		return (DefWindowProc(hwnd, message, wParam, lParam));
}


/////  DlgProc̏  //////////////////////////////////////////////////////

BOOL FAR PASCAL About(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WPARAM wParam;
LPARAM lParam;
{
	switch (message) {
	case WM_INITDIALOG:
		return (TRUE);

	case WM_COMMAND:
		if (GET_WM_COMMAND_ID(wParam, lParam) == IDOK
				|| GET_WM_COMMAND_ID(wParam, lParam) == IDCANCEL) {
		EndDialog(hDlg, TRUE);
		return (TRUE);
		}
		break;
	}
	return (FALSE);
}

