#### PNGSCAN: PNG̉

unless(open(RD,$ARGV[0])){ print "File not found."; exit; }
binmode(RD);

&initcrc32p;		# CRC32e[uݒ


read(RD,$_,8);
if($_ ne "PNG\r\n\x1a\n"){
 print "Not PNG file."; exit;
}

print "\n\nPNG header ok.\n";

$cnt=0;

{
 unless(read(RD,$_,8)){ last; }
 ($len,$ch)=unpack("NA4",$_);			#A`N
 print "Len=$len,$ch,";

 read(RD,$mes,$len);
 read(RD,$_,4); $_=unpack("N",$_);
											#CRCvZ̑Ώۂݸ+{
 printf("CRC=%8.8lxH   CRC(calc)=%8.8lxH\n",$_, &crc32p("$ch$mes"));

 if($ch eq "IHDR"){
  ($wd,$ht, $bt,$cl, $pr,$pre,$in)=unpack("NNCCCCC",$mes);
  print " ${wd}x$ht ${bt}bit CMode=$cl  [$pr,$pre,$in]\n";
 }


 open(WRT,">f:\\CHUNK$cnt.dat"); binmode(WRT);
 print WRT $mes; close(WRT); $cnt++;

 redo;
}

exit;


#####  Tu[`@#######################################################

#####@&initcrc32p: pngCRC̃e[uݒ

sub initcrc32p{
 print "CRC32 table making...";

 for($n=0; $n< 256; $n++){
  $c =$n;

  for ($k = 0; $k < 8; $k++) {
   if ($c & 1){ $c = 0xedb88320 ^ (($c >> 1)&0xffffffff); }
   else{        $c = ($c >> 1)&0xffffffff; }
  }
  $CRC32TBL[$n]=$c;

  #printf("0x%8.8lx,",$c); if(($n %5)==4){ print "\n"; }

 }

 #print join(" ",@CRC32TBL);

}


#####@&crc32p: pngCRC32vZ

sub crc32p{
 local($txt,$c,$i,$len)=($_[0],0xffffffff);			# $txtɕ

 $len=length($txt);

 for($i=0; $i<$len; $i++){
  $c= $CRC32TBL[ ($c & 0xff) ^ unpack("C",substr($txt,$i,1)) ] ^ (($c & 0xffffff00) >>8);
 }


 $c ^= 0xffffffff; $c;				#߂l
}


#####  o@############################################################
__END__

///@CRC32vZ

   /* Update a running CRC with the bytes buf[0..len-1]--the CRC
      should be initialized to all 1's, and the transmitted value
      is the 1's complement of the final running CRC (see the
      crc() routine below)). */
   
   unsigned long update_crc(unsigned long crc, unsigned char *buf,
                            int len)
   {
     unsigned long c = crc;
     int n;
   
     if (!crc_table_computed)
       make_crc_table();

     for (n = 0; n < len; n++) {
       c = crc_table[(c ^ buf[n]) & 0xff] ^ (c >> 8);
     }

     return c;
   }
   
   /* Return the CRC of the bytes buf[0..len-1]. */
   unsigned long crc(unsigned char *buf, int len)
   {
     return update_crc(0xffffffffL, buf, len) ^ 0xffffffffL;
   }


/// CRC32e[u쐬

   /* Make the table for a fast CRC. */
   void make_crc_table(void)
   {
     unsigned long c;
     int n, k;
   
     for (n = 0; n < 256; n++) {
       c = (unsigned long) n;
       for (k = 0; k < 8; k++) {
         if (c & 1)
           c = 0xedb88320L ^ (c >> 1);
         else
           c = c >> 1;
       }
       crc_table[n] = c;
     }
     crc_table_computed = 1;
   }



PNGCRC32: http://www.faqs.org/rfcs/rfc2083.html
{Ń\[X: http://www.sutv.zaq.ne.jp/linuz/tks/PngSpec1.2/PNG-CRCAppendix.html


  x^32+x^26+x^23+x^22+x^16+x^12+x^11+x^10+x^8+x^7+x^5+x^4+x^2+x+1




00000: 89504e47 0d0a1a0a						PNG\r\n(ry@cʎq
						 0000000d 49484452 
00010: 000001e0 00000320 04030000 00098dac 
00020: 3b
		 000000 30504c54 458f0f0f 000000af 
00030: cfef5f7f cfff8f8f ef3f3f0f 8f2f1f6f 
00040: 2fffdf7f ffdfcfff af9fdf7f 6f9f3f2f 
00050: cfcfcf7f 7f7fffff ffd94f13 14000020 
00060: 00494441 54789cdc bdcf6f1b 4bb6e7d9 
00070: ef3fa824 3723524a 21a51539 d51428ee 
00080: 6fadfba1 81f99b7a 77513540 43446f48 



08(4):  0000000d							len=0dH 13oCg
0c(4):  49484452							"IHDR"
10(13): 000001e0 00000320 04030000 00		IHDR`Ng
1d(4):  098dac3b							CRC32

21(4):  00000030							len=30H 48oCg

